SystemOrganization addCategory: #'FOOPSnake-Model'!
SystemOrganization addCategory: #'FOOPSnake-Graphics'!

Morph subclass: #FOOPSnakeMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FOOPSnake-Graphics'!

!FOOPSnakeMorph methodsFor: 'initialization' stamp: 'sb 6/10/2013 15:51'!
initialize
	| gameInstance playfieldMorph |
	super initialize.
	gameInstance := GameInstance new.
	gameInstance foopSnakeMorph: self.
	playfieldMorph := PlayfieldMorph new.
	playfieldMorph gameInstance: gameInstance.
	playfieldMorph extent: (PlayfieldMorph getExtentFor: gameInstance playfield).
	self addMorph: playfieldMorph.
	self extent: playfieldMorph extent.! !

Morph subclass: #PlayfieldMorph
	instanceVariableNames: 'gameInstance'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FOOPSnake-Graphics'!

!PlayfieldMorph class methodsFor: 'as yet unclassified' stamp: 'sb 6/10/2013 16:19'!
cellPadding
	^1@1! !

!PlayfieldMorph class methodsFor: 'as yet unclassified' stamp: 'sb 6/10/2013 16:28'!
getExtentFor: aPlayfield
	^((aPlayfield dimension) * ((CellRenderer cellExtent) + (self cellPadding)) + (self cellPadding))! !

!PlayfieldMorph methodsFor: 'drawing' stamp: 'sb 6/10/2013 18:03'!
drawOn: aCanvas
	| cells dim snakePart renderer |
	super drawOn: aCanvas.
	dim := gameInstance playfield dimension.
	cells := gameInstance playfield cells.
	0 to: dim x - 1 do: [:x |
		0 to: dim y - 1 do: [:y |
			(cells includesKey: x@y)
				ifTrue: [snakePart := cells at: x@y]
				ifFalse: [snakePart := nil].
			renderer := CellRenderer rendererFor: snakePart position: x@y playfieldMorph: self canvas: aCanvas.
		renderer render]].! !

!PlayfieldMorph methodsFor: 'accessing' stamp: 'sb 6/10/2013 15:18'!
gameInstance

	^ gameInstance! !

!PlayfieldMorph methodsFor: 'accessing' stamp: 'sb 6/10/2013 15:18'!
gameInstance: anObject

	gameInstance := anObject! !

!PlayfieldMorph methodsFor: 'initialization' stamp: 'sb 6/10/2013 15:23'!
initialize
	super initialize.
	self color: Color white.! !

Object subclass: #CellRenderer
	instanceVariableNames: 'playfieldMorph position snakePart canvas'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FOOPSnake-Graphics'!

!CellRenderer class methodsFor: 'as yet unclassified' stamp: 'sb 6/10/2013 16:12'!
cellExtent
	^10@10! !

!CellRenderer class methodsFor: 'as yet unclassified' stamp: 'sb 6/10/2013 17:40'!
rendererFor: aSnakePart
	aSnakePart = nil ifTrue: [^self].
	^self subclasses detect: [:cls | cls modelClass = aSnakePart class]! !

!CellRenderer class methodsFor: 'as yet unclassified' stamp: 'sb 6/10/2013 17:43'!
rendererFor: aSnakePart position: aPoint playfieldMorph: aPlayfieldMorph canvas: aCanvas
	| cls model |
	cls := self rendererFor: aSnakePart.
	model := cls new.
	model
		snakePart: aSnakePart;
		position: aPoint;
		playfieldMorph: aPlayfieldMorph;
		canvas: aCanvas.
	^model! !

!CellRenderer methodsFor: 'accessing' stamp: 'sb 6/10/2013 16:42'!
canvas

	^ canvas! !

!CellRenderer methodsFor: 'accessing' stamp: 'sb 6/10/2013 16:42'!
canvas: anObject

	canvas := anObject! !

!CellRenderer methodsFor: 'private' stamp: 'sb 6/10/2013 19:01'!
getOrigin
	| playfieldOrigin positionDelta |
	playfieldOrigin := playfieldMorph bounds origin + PlayfieldMorph cellPadding.
	positionDelta := (self class cellExtent + PlayfieldMorph cellPadding) * position.
	^playfieldOrigin + positionDelta! !

!CellRenderer methodsFor: 'accessing' stamp: 'sb 6/10/2013 17:43'!
playfieldMorph

	^ playfieldMorph! !

!CellRenderer methodsFor: 'accessing' stamp: 'sb 6/10/2013 17:43'!
playfieldMorph: anObject

	playfieldMorph := anObject! !

!CellRenderer methodsFor: 'accessing' stamp: 'sb 6/10/2013 17:36'!
position

	^ position! !

!CellRenderer methodsFor: 'accessing' stamp: 'sb 6/10/2013 17:36'!
position: anObject

	position := anObject! !

!CellRenderer methodsFor: 'drawing' stamp: 'sb 6/10/2013 19:02'!
render
	| rectangle |
	rectangle := Rectangle origin: self getOrigin extent: self class cellExtent.
	canvas fillRectangle: rectangle color: Color lightGray.! !

!CellRenderer methodsFor: 'accessing' stamp: 'sb 6/10/2013 16:34'!
snakePart

	^ snakePart! !

!CellRenderer methodsFor: 'accessing' stamp: 'sb 6/10/2013 16:34'!
snakePart: anObject

	snakePart := anObject! !

CellRenderer subclass: #SnakeHeadRenderer
	instanceVariableNames: ''
	classVariableNames: 'DirectionPolygonOffsets'
	poolDictionaries: ''
	category: 'FOOPSnake-Graphics'!

!SnakeHeadRenderer class methodsFor: 'as yet unclassified' stamp: 'sb 6/10/2013 20:30'!
getPolygonOffsetForDirection: aDirectionSymbol
	DirectionPolygonOffsets = nil ifTrue: [self initializePolygonOffsets].
	^DirectionPolygonOffsets at: aDirectionSymbol.! !

!SnakeHeadRenderer class methodsFor: 'class initialization' stamp: 'sb 6/10/2013 20:30'!
initialize
	super initialize.
	self initializePolygonOffsets. 
	! !

!SnakeHeadRenderer class methodsFor: 'class initialization' stamp: 'sb 6/10/2013 20:33'!
initializePolygonOffsets
	"self initializePolygonOffsets"
	| left right middle |
	
	left := 0.
	middle := self cellExtent x / 2.0.
	right := self cellExtent x.
	
	DirectionPolygonOffsets := Dictionary newFrom: {
								#north->{middle@left. left@right. right@right}. 
						    		#south->{middle@right. left@left. right@left}.
								#east->{left@middle. right@left. right@left}.
								#west->{right@middle. left@left. left@right}}.! !

!SnakeHeadRenderer class methodsFor: 'as yet unclassified' stamp: 'sb 6/10/2013 18:35'!
modelClass
	^SnakeHead! !

!SnakeHeadRenderer methodsFor: 'drawing' stamp: 'sb 6/10/2013 20:41'!
render
	| origin polygons |
	super render.
	
	origin := self getOrigin.
	polygons := self class getPolygonOffsetForDirection: snakePart direction.
	polygons := {(polygons at: 1) + origin. (polygons at: 2) + origin. (polygons at: 3) + origin}.
	canvas drawPolygon: polygons fillStyle: snakePart color.! !

CellRenderer subclass: #SnakePartRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FOOPSnake-Graphics'!

!SnakePartRenderer class methodsFor: 'as yet unclassified' stamp: 'sb 6/10/2013 18:28'!
modelClass
	^SnakePart! !

!SnakePartRenderer methodsFor: 'drawing' stamp: 'sb 6/10/2013 19:02'!
render
	| rectangle |
	rectangle := Rectangle origin: self getOrigin extent: self class cellExtent.
	canvas fillRectangle: rectangle color: snakePart color.! !

Object subclass: #Direction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FOOPSnake-Model'!

!Direction class methodsFor: 'as yet unclassified' stamp: 'sb 6/10/2013 19:18'!
directionFor: aSymbol
	^self subclasses detect: [:cls | cls directionSymbol = aSymbol]! !

Direction subclass: #DirectionEast
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FOOPSnake-Model'!

!DirectionEast class methodsFor: 'as yet unclassified' stamp: 'sb 6/10/2013 19:19'!
directionSymbol
	^#east! !

Direction subclass: #DirectionNorth
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FOOPSnake-Model'!

!DirectionNorth class methodsFor: 'as yet unclassified' stamp: 'sb 6/10/2013 19:19'!
directionSymbol
	^#north! !

Direction subclass: #DirectionSouth
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FOOPSnake-Model'!

!DirectionSouth class methodsFor: 'as yet unclassified' stamp: 'sb 6/10/2013 19:19'!
directionSymbol
	^#south! !

Direction subclass: #DirectionWest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FOOPSnake-Model'!

!DirectionWest class methodsFor: 'as yet unclassified' stamp: 'sb 6/10/2013 19:19'!
directionSymbol
	^#west! !

Object subclass: #GameInstance
	instanceVariableNames: 'foopSnakeMorph playfield'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FOOPSnake-Model'!

!GameInstance class methodsFor: 'as yet unclassified' stamp: 'sb 6/10/2013 20:25'!
createTestPlayfield
	| playfield snakePart |
	playfield := Playfield new.
	
	snakePart := SnakeHead new.
	snakePart color: Color blue.
	snakePart direction: DirectionNorth directionSymbol.
	playfield cells at: 20@20 put: snakePart.
	
	snakePart := SnakePart new.
	snakePart color: Color blue.
	playfield cells at: 20@21 put: snakePart.
	
	snakePart := SnakePart new.
	snakePart color: Color blue.
	playfield cells at: 20@22 put: snakePart.
	
	snakePart := SnakeHead new.
	snakePart color: Color black.
	snakePart direction: DirectionNorth directionSymbol.
	playfield cells at: 21@20 put: snakePart.
	
	snakePart := SnakePart new.
	snakePart color: Color black.
	playfield cells at: 21@21 put: snakePart.
	
	snakePart := SnakePart new.
	snakePart color: Color black.
	playfield cells at: 21@22 put: snakePart.

	^playfield! !

!GameInstance methodsFor: 'accessing' stamp: 'sb 6/10/2013 15:10'!
foopSnakeMorph
	^foopSnakeMorph! !

!GameInstance methodsFor: 'accessing' stamp: 'sb 6/10/2013 15:10'!
foopSnakeMorph: aFoopSnakeMorph
	foopSnakeMorph := aFoopSnakeMorph.! !

!GameInstance methodsFor: 'initialization' stamp: 'sb 6/10/2013 18:33'!
initialize
	playfield := self class createTestPlayfield.! !

!GameInstance methodsFor: 'accessing' stamp: 'sb 6/10/2013 15:16'!
playfield

	^ playfield! !

!GameInstance methodsFor: 'accessing' stamp: 'sb 6/10/2013 15:16'!
playfield: anObject

	playfield := anObject! !

Object subclass: #Playfield
	instanceVariableNames: 'cells dimension'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FOOPSnake-Model'!

!Playfield methodsFor: 'accessing' stamp: 'sb 6/10/2013 16:27'!
cells
	^cells! !

!Playfield methodsFor: 'accessing' stamp: 'sb 6/10/2013 18:07'!
dimension
	^40@40! !

!Playfield methodsFor: 'initialization' stamp: 'sb 6/10/2013 14:56'!
initialize
	cells := Dictionary new.! !

Object subclass: #SnakePart
	instanceVariableNames: 'color direction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FOOPSnake-Model'!

SnakePart subclass: #SnakeHead
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'FOOPSnake-Model'!

!SnakePart methodsFor: 'accessing' stamp: 'sb 6/10/2013 18:30'!
color

	^ color! !

!SnakePart methodsFor: 'accessing' stamp: 'sb 6/10/2013 18:30'!
color: anObject

	color := anObject! !

!SnakePart methodsFor: 'accessing' stamp: 'sb 6/10/2013 19:34'!
direction

	^ direction! !

!SnakePart methodsFor: 'accessing' stamp: 'sb 6/10/2013 19:34'!
direction: anObject

	direction := anObject! !
SnakeHeadRenderer initialize!
